diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/components/sounds.h alien-rc4/src//game/client/components/sounds.h
--- teeworlds-b177-r50edfd37-source/src//game/client/components/sounds.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/components/sounds.h	2012-06-14 23:57:39.000000000 +0200
@@ -19,6 +19,8 @@ class CSounds : public CComponent
 	int64 m_QueueWaitTime;
 	class CJob m_SoundJob;
 	bool m_WaitForSoundJob;
+	
+	int GetSampleId(int SetId);
 
 public:
 	// sound channels
@@ -37,7 +39,8 @@ public:
 
 	void ClearQueue();
 	void Enqueue(int Channel, int SetId);
-	void Play(int Channel, int SetId, float Vol, vec2 Pos);
+	void Play(int Channel, int SetId, float Vol);
+	void PlayAt(int Channel, int SetId, float Vol, vec2 Pos);
 	void PlayAndRecord(int Channel, int SetId, float Vol, vec2 Pos);
 	void Stop(int SetId);
 };
diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/gameclient.cpp alien-rc4/src//game/client/gameclient.cpp
--- teeworlds-b177-r50edfd37-source/src//game/client/gameclient.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/gameclient.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -95,7 +95,6 @@ void CGameClient::OnConsoleInit()
 {
 	m_pEngine = Kernel()->RequestInterface<IEngine>();
 	m_pClient = Kernel()->RequestInterface<IClient>();
-	m_pGraphics = Kernel()->RequestInterface<IGraphics>();
 	m_pTextRender = Kernel()->RequestInterface<ITextRender>();
 	m_pSound = Kernel()->RequestInterface<ISound>();
 	m_pInput = Kernel()->RequestInterface<IInput>();
@@ -126,6 +125,8 @@ void CGameClient::OnConsoleInit()
 	m_pVoting = &::gs_Voting;
 	m_pScoreboard = &::gs_Scoreboard;
 	m_pItems = &::gs_Items;
+	m_pMapLayersBackGround = &::gs_MapLayersBackGround;
+	m_pMapLayersForeGround = &::gs_MapLayersForeGround;
 
 	// make a list of all the systems, make sure to add them in the corrent render order
 	m_All.Add(m_pSkins);
@@ -192,12 +193,10 @@ void CGameClient::OnConsoleInit()
 	Console()->Register("force_vote", "ss?r", CFGFLAG_SERVER, 0, 0, "Force a voting option");
 	Console()->Register("clear_votes", "", CFGFLAG_SERVER, 0, 0, "Clears the voting options");
 	Console()->Register("vote", "r", CFGFLAG_SERVER, 0, 0, "Force a vote to yes/no");
+	Console()->Register("swap_teams", "", CFGFLAG_SERVER, 0, 0, "Swap the current teams");
+	Console()->Register("shuffle_teams", "", CFGFLAG_SERVER, 0, 0, "Shuffle the current teams");
 
 
-	// propagate pointers
-	m_UI.SetGraphics(Graphics(), TextRender());
-	m_RenderTools.m_pGraphics = Graphics();
-	m_RenderTools.m_pUI = UI();
 	for(int i = 0; i < m_All.m_Num; i++)
 		m_All.m_paComponents[i]->m_pClient = this;
 
@@ -221,6 +220,13 @@ void CGameClient::OnConsoleInit()
 
 void CGameClient::OnInit()
 {
+	m_pGraphics = Kernel()->RequestInterface<IGraphics>();
+
+	// propagate pointers
+	m_UI.SetGraphics(Graphics(), TextRender());
+	m_RenderTools.m_pGraphics = Graphics();
+	m_RenderTools.m_pUI = UI();
+	
 	int64 Start = time_get();
 
 	// set the language
@@ -443,7 +449,7 @@ void CGameClient::OnRender()
 	m_NewPredictedTick = false;
 
 	// check if client info has to be resent
-	if(m_LastSendInfo && Client()->State() == IClient::STATE_ONLINE && !m_pMenus->IsActive() && m_LastSendInfo+time_freq()*5 < time_get())
+	if(m_LastSendInfo && Client()->State() == IClient::STATE_ONLINE && m_Snap.m_LocalClientID >= 0 && !m_pMenus->IsActive() && m_LastSendInfo+time_freq()*5 < time_get())
 	{
 		// resend if client info differs
 		if(str_comp(g_Config.m_PlayerName, m_aClients[m_Snap.m_LocalClientID].m_aName) ||
@@ -545,7 +551,7 @@ void CGameClient::OnMessage(int MsgId, C
 			pMsg->m_SoundID == SOUND_CTF_GRAB_PL)
 			g_GameClient.m_pSounds->Enqueue(CSounds::CHN_GLOBAL, pMsg->m_SoundID);
 		else
-			g_GameClient.m_pSounds->Play(CSounds::CHN_GLOBAL, pMsg->m_SoundID, 1.0f, vec2(0,0));
+			g_GameClient.m_pSounds->Play(CSounds::CHN_GLOBAL, pMsg->m_SoundID, 1.0f);
 	}
 }
 
@@ -620,7 +626,7 @@ void CGameClient::ProcessEvents()
 		else if(Item.m_Type == NETEVENTTYPE_SOUNDWORLD)
 		{
 			CNetEvent_SoundWorld *ev = (CNetEvent_SoundWorld *)pData;
-			g_GameClient.m_pSounds->Play(CSounds::CHN_WORLD, ev->m_SoundID, 1.0f, vec2(ev->m_X, ev->m_Y));
+			g_GameClient.m_pSounds->PlayAt(CSounds::CHN_WORLD, ev->m_SoundID, 1.0f, vec2(ev->m_X, ev->m_Y));
 		}
 	}
 }
@@ -862,6 +868,17 @@ void CGameClient::OnNewSnapshot()
 			}
 		}
 	}
+	// sort player infos by team
+	int Teams[3] = { TEAM_RED, TEAM_BLUE, TEAM_SPECTATORS };
+	int Index = 0;
+	for(int Team = 0; Team < 3; ++Team)
+	{
+		for(int i = 0; i < MAX_CLIENTS && Index < MAX_CLIENTS; ++i)
+		{
+			if(m_Snap.m_paPlayerInfos[i] && m_Snap.m_paPlayerInfos[i]->m_Team == Teams[Team])
+				m_Snap.m_paInfoByTeam[Index++] = m_Snap.m_paPlayerInfos[i];
+		}
+	}
 
 	CTuningParams StandardTuning;
 	CServerInfo CurrentServerInfo;
@@ -876,6 +893,15 @@ void CGameClient::OnNewSnapshot()
 			m_ServerMode = SERVERMODE_PUREMOD;
 	}
 
+	// add tuning to demo
+	if(DemoRecorder()->IsRecording() && mem_comp(&StandardTuning, &m_Tuning, sizeof(CTuningParams)) != 0)
+	{
+		CMsgPacker Msg(NETMSGTYPE_SV_TUNEPARAMS);
+		int *pParams = (int *)&m_Tuning;
+		for(unsigned i = 0; i < sizeof(m_Tuning)/sizeof(int); i++)
+			Msg.AddInt(pParams[i]);
+		Client()->SendMsg(&Msg, MSGFLAG_RECORD|MSGFLAG_NOSEND);
+	}
 }
 
 void CGameClient::OnPredict()
diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/gameclient.h alien-rc4/src//game/client/gameclient.h
--- teeworlds-b177-r50edfd37-source/src//game/client/gameclient.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/gameclient.h	2012-06-14 23:57:39.000000000 +0200
@@ -125,6 +125,7 @@ public:
 
 		const CNetObj_PlayerInfo *m_paPlayerInfos[MAX_CLIENTS];
 		const CNetObj_PlayerInfo *m_paInfoByScore[MAX_CLIENTS];
+		const CNetObj_PlayerInfo *m_paInfoByTeam[MAX_CLIENTS];
 
 		int m_LocalClientID;
 		int m_NumPlayers;
@@ -241,6 +242,8 @@ public:
 	class CVoting *m_pVoting;
 	class CScoreboard *m_pScoreboard;
 	class CItems *m_pItems;
+	class CMapLayers *m_pMapLayersBackGround;
+	class CMapLayers *m_pMapLayersForeGround;
 };
 
 
diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/render.cpp alien-rc4/src//game/client/render.cpp
--- teeworlds-b177-r50edfd37-source/src//game/client/render.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/render.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -75,7 +75,7 @@ void CRenderTools::SelectSprite(CDataSpr
 
 void CRenderTools::SelectSprite(int Id, int Flags, int sx, int sy)
 {
-	if(Id < 0 || Id > g_pData->m_NumSprites)
+	if(Id < 0 || Id >= g_pData->m_NumSprites)
 		return;
 	SelectSprite(&g_pData->m_aSprites[Id], Flags, sx, sy);
 }
diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/ui.cpp alien-rc4/src//game/client/ui.cpp
--- teeworlds-b177-r50edfd37-source/src//game/client/ui.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/ui.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -74,6 +74,11 @@ CUIRect *CUI::Screen()
 	return &m_Screen;
 }
 
+float CUI::PixelSize()
+{
+	return Screen()->w/Graphics()->ScreenWidth();
+}
+
 void CUI::SetScale(float s)
 {
 	g_Config.m_UiScale = (int)(s*100.0f);
diff -rupN teeworlds-b177-r50edfd37-source/src//game/client/ui.h alien-rc4/src//game/client/ui.h
--- teeworlds-b177-r50edfd37-source/src//game/client/ui.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/client/ui.h	2012-06-14 23:57:39.000000000 +0200
@@ -82,6 +82,7 @@ public:
 	void ConvertMouseMove(float *x, float *y);
 
 	CUIRect *Screen();
+	float PixelSize();
 	void ClipEnable(const CUIRect *pRect);
 	void ClipDisable();
 
diff -rupN teeworlds-b177-r50edfd37-source/src//game/collision.cpp alien-rc4/src//game/collision.cpp
--- teeworlds-b177-r50edfd37-source/src//game/collision.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/collision.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -45,6 +45,24 @@ void CCollision::Init(class CLayers *pLa
 		case TILE_NOHOOK:
 			m_pTiles[i].m_Index = COLFLAG_SOLID|COLFLAG_NOHOOK;
 			break;
+		case TILE_TURRET:
+			m_pTiles[i].m_Index = COLFLAG_TURRET;
+			break;
+		case TILE_INVIS:
+			m_pTiles[i].m_Index = COLFLAG_INVIS;
+			break;
+		case TILE_BIOHAZARD:
+			m_pTiles[i].m_Index = COLFLAG_BIOHAZARD;
+			break;
+		case TILE_BIOINVIS:
+			m_pTiles[i].m_Index = COLFLAG_BIOINVIS;
+			break;
+		case TILE_ENERGYUP:
+			m_pTiles[i].m_Index = COLFLAG_ENERGYUP;
+			break;
+		case TILE_REAPER:
+			m_pTiles[i].m_Index = COLFLAG_REAPER;
+			break;
 		default:
 			m_pTiles[i].m_Index = 0;
 		}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/collision.h alien-rc4/src//game/collision.h
--- teeworlds-b177-r50edfd37-source/src//game/collision.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/collision.h	2012-06-14 23:57:39.000000000 +0200
@@ -21,6 +21,12 @@ public:
 		COLFLAG_SOLID=1,
 		COLFLAG_DEATH=2,
 		COLFLAG_NOHOOK=4,
+		COLFLAG_TURRET=8,
+		COLFLAG_INVIS=16,
+		COLFLAG_BIOHAZARD=32,
+		COLFLAG_BIOINVIS=48,
+		COLFLAG_ENERGYUP=64,
+		COLFLAG_REAPER=128,
 	};
 
 	CCollision();
